Index: /code/branches/presentation2/src/libraries/core/IOConsole.cc
===================================================================
--- /code/branches/presentation2/src/libraries/core/IOConsole.cc	(revision 6179)
+++ /code/branches/presentation2/src/libraries/core/IOConsole.cc	(revision 6180)
@@ -45,22 +45,4 @@
     IOConsole* IOConsole::singletonPtr_s = NULL;
 
-    //! Extracts the log level associated to a string (first character)
-    int IOConsole::extractLogLevel(std::string* text)
-    {
-        // Handle line colouring by inspecting the first letter
-        char level = 0;
-        if (!text->empty())
-        {
-            level = (*text)[0];
-            if (level == -1 || (level >= 1 && level <= 6))
-            {
-                *text = text->substr(1);
-                if (level != -1)
-                    return level;
-            }
-        }
-        return 0;
-    }
-
     // ###############################
     // ###  ShellListener methods  ###
@@ -78,5 +60,5 @@
     void IOConsole::executed()
     {
-        this->shell_->addOutputLine(this->promptString_ + this->shell_->getInput());
+        this->shell_->addOutputLine(this->promptString_ + this->shell_->getInput(), Shell::Command);
     }
 
@@ -109,5 +91,5 @@
 
     IOConsole::IOConsole()
-        : shell_(new Shell("IOConsole", false, true))
+        : shell_(new Shell("IOConsole", false))
         , buffer_(shell_->getInputBuffer())
         , cout_(std::cout.rdbuf())
@@ -280,25 +262,22 @@
         if (!this->origCout_.str().empty())
         {
-            this->shell_->addOutputLine(this->origCout_.str());
+            this->shell_->addOutputLine(this->origCout_.str(), Shell::None);
             this->origCout_.str("");
         }
     }
 
-    void IOConsole::printOutputLine(const std::string& text)
-    {
-        std::string output = text;
-        /*int level =*/ this->extractLogLevel(&output);
-
+    void IOConsole::printOutputLine(const std::string& text, Shell::LineType type)
+    {
 /*
         // Colour line
-        switch (level)
-        {
-        case -1: this->cout_ << "\033[37m"; break;
-        case  1: this->cout_ << "\033[91m"; break;
-        case  2: this->cout_ << "\033[31m"; break;
-        case  3: this->cout_ << "\033[34m"; break;
-        case  4: this->cout_ << "\033[36m"; break;
-        case  5: this->cout_ << "\033[35m"; break;
-        case  6: this->cout_ << "\033[37m"; break;
+        switch (type)
+        {
+        case Shell::None:    this->cout_ << "\033[37m"; break;
+        case Shell::Error:   this->cout_ << "\033[91m"; break;
+        case Shell::Warning: this->cout_ << "\033[31m"; break;
+        case Shell::Info:    this->cout_ << "\033[34m"; break;
+        case Shell::Debug:   this->cout_ << "\033[36m"; break;
+        case Shell::Verbose: this->cout_ << "\033[35m"; break;
+        case Shell::Ultra:   this->cout_ << "\033[37m"; break;
         default: break;
         }
@@ -306,5 +285,5 @@
 
         // Print output line
-        this->cout_ << output;
+        this->cout_ << text;
 
         // Reset colour to white
@@ -419,5 +398,5 @@
         this->cout_ << "\033[K";
         // Reprint the last output line
-        this->printOutputLine(*(this->shell_->getNewestLineIterator()));
+        this->printOutputLine(this->shell_->getNewestLineIterator()->first);
         // Restore cursor
         this->cout_ << "\033[u";
@@ -428,5 +407,5 @@
     void IOConsole::lineAdded()
     {
-        int newLines = this->shell_->getNewestLineIterator()->size() / this->terminalWidth_ + 1;
+        int newLines = this->shell_->getNewestLineIterator()->first.size() / this->terminalWidth_ + 1;
         // Create new lines by scrolling the screen
         this->cout_ << "\033[" << newLines << 'S';
@@ -437,5 +416,5 @@
         // Print the new output lines
         for (int i = 0; i < newLines; ++i)
-            this->printOutputLine(this->shell_->getNewestLineIterator()->substr(i*this->terminalWidth_, this->terminalWidth_));
+            this->printOutputLine(this->shell_->getNewestLineIterator()->first.substr(i*this->terminalWidth_, this->terminalWidth_));
         // Move cursor down
         this->cout_ << "\033[1B\033[1G";
@@ -472,5 +451,5 @@
     //! Redirects std::cout, creates the corresponding Shell and changes the terminal mode
     IOConsole::IOConsole()
-        : shell_(new Shell("IOConsole", false, true))
+        : shell_(new Shell("IOConsole", false))
         , buffer_(shell_->getInputBuffer())
         , cout_(std::cout.rdbuf())
@@ -613,5 +592,5 @@
         if (!this->origCout_.str().empty())
         {
-            this->shell_->addOutputLine(this->origCout_.str());
+            this->shell_->addOutputLine(this->origCout_.str(), Shell::None);
             this->origCout_.str("");
         }
@@ -619,22 +598,23 @@
 
     //! Prints output text. Similar to writeText, but sets the colour according to the output level
-    void IOConsole::printOutputLine(const std::string& text, const COORD& pos)
-    {
-        std::string output = text;
-        int level = this->extractLogLevel(&output);
-
+    void IOConsole::printOutputLine(const std::string& text, Shell::LineType type, const COORD& pos)
+    {
         // Colour line
         WORD colour = 0;
-        switch (level)
-        {
-        case  1: colour = FOREGROUND_INTENSITY                    | FOREGROUND_RED ; break;
-        case  2: colour = FOREGROUND_INTENSITY | FOREGROUND_GREEN | FOREGROUND_RED ; break;
-        case  3: colour = FOREGROUND_INTENSITY                                     ; break;
-        case  4: colour = FOREGROUND_INTENSITY                                     ; break;
-        default: colour =                        FOREGROUND_GREEN | FOREGROUND_RED | FOREGROUND_BLUE ; break;
+        switch (type)
+        {
+        case Shell::Error:   colour = FOREGROUND_INTENSITY                    | FOREGROUND_RED; break;
+        case Shell::Warning: colour = FOREGROUND_INTENSITY | FOREGROUND_GREEN | FOREGROUND_RED; break;
+        case Shell::Info:
+        case Shell::Debug:
+        case Shell::Verbose:
+        case Shell::Ultra:   colour = FOREGROUND_INTENSITY                                     ; break;
+        case Shell::Command: colour =                        FOREGROUND_GREEN                  | FOREGROUND_BLUE; break;
+        case Shell::Hint:    colour =                        FOREGROUND_GREEN | FOREGROUND_RED                  ; break;
+        default:             colour =                        FOREGROUND_GREEN | FOREGROUND_RED | FOREGROUND_BLUE; break;
         }
 
         // Print output line
-        this->writeText(output, pos, colour);
+        this->writeText(text, pos, colour);
     }
 
@@ -783,5 +763,5 @@
     void IOConsole::onlyLastLineChanged()
     {
-        int newLineHeight = 1 + this->shell_->getNewestLineIterator()->size() / this->terminalWidth_;
+        int newLineHeight = 1 + this->shell_->getNewestLineIterator()->first.size() / this->terminalWidth_;
         // Compute the number of new lines needed
         int newLines = newLineHeight - this->lastOutputLineHeight_;
@@ -790,5 +770,6 @@
         if (newLines > 0) // newLines < 0 is assumed impossible
             this->createNewOutputLines(newLines);
-        this->printOutputLine(*(this->shell_->getNewestLineIterator()), makeCOORD(0, this->inputLineRow_ - newLineHeight));
+        Shell::LineList::const_iterator it = this->shell_->getNewestLineIterator();
+        this->printOutputLine(it->first, it->second, makeCOORD(0, this->inputLineRow_ - newLineHeight));
     }
 
@@ -796,10 +777,11 @@
     void IOConsole::lineAdded()
     {
+        Shell::LineList::const_iterator it = this->shell_->getNewestLineIterator();
         // Scroll console
-        this->lastOutputLineHeight_ = 1 + this->shell_->getNewestLineIterator()->size() / this->terminalWidth_;
+        this->lastOutputLineHeight_ = 1 + it->first.size() / this->terminalWidth_;
         this->createNewOutputLines(this->lastOutputLineHeight_);
         // Write the text
         COORD pos = {0, this->inputLineRow_ - this->lastOutputLineHeight_};
-        this->printOutputLine(*(this->shell_->getNewestLineIterator()), pos);
+        this->printOutputLine(it->first, it->second, pos);
     }
 }
Index: /code/branches/presentation2/src/libraries/core/IOConsole.h
===================================================================
--- /code/branches/presentation2/src/libraries/core/IOConsole.h	(revision 6179)
+++ /code/branches/presentation2/src/libraries/core/IOConsole.h	(revision 6180)
@@ -87,5 +87,5 @@
         bool willPrintStatusLines();
         void printInputLine();
-        void printOutputLine(const std::string& line);
+        void printOutputLine(const std::string& line, Shell::LineType type);
         static void resetTerminalMode();
 
@@ -102,5 +102,5 @@
         void writeText(const std::string& text, const COORD& pos, WORD attributes = FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_RED);
         void createNewOutputLines(int lines);
-        void printOutputLine(const std::string& line, const COORD& pos);
+        void printOutputLine(const std::string& line, Shell::LineType type, const COORD& pos);
 
         static inline COORD makeCOORD(int x, int y)
Index: /code/branches/presentation2/src/libraries/core/Shell.cc
===================================================================
--- /code/branches/presentation2/src/libraries/core/Shell.cc	(revision 6179)
+++ /code/branches/presentation2/src/libraries/core/Shell.cc	(revision 6180)
@@ -45,9 +45,8 @@
     SetConsoleCommandShortcut(OutputHandler, debug);
 
-    Shell::Shell(const std::string& consoleName, bool bScrollable, bool bPrependOutputLevel)
+    Shell::Shell(const std::string& consoleName, bool bScrollable)
         : OutputListener(consoleName)
         , inputBuffer_(new InputBuffer())
         , consoleName_(consoleName)
-        , bPrependOutputLevel_(bPrependOutputLevel)
         , bScrollable_(bScrollable)
     {
@@ -191,5 +190,5 @@
     }
 
-    void Shell::addOutputLine(const std::string& line, int level)
+    void Shell::addOutputLine(const std::string& line, LineType type)
     {
         // Make sure we really only have one line per line (no new lines!)
@@ -197,6 +196,5 @@
         for (unsigned i = 0; i < lines.size(); ++i)
         {
-            if (level <= this->softDebugLevel_)
-                this->outputLines_.push_front(lines[i]);
+            this->outputLines_.push_front(std::make_pair(lines[i], type));
             this->updateListeners<&ShellListener::lineAdded>();
         }
@@ -214,5 +212,5 @@
     }
 
-    std::list<std::string>::const_iterator Shell::getNewestLineIterator() const
+    Shell::LineList::const_iterator Shell::getNewestLineIterator() const
     {
         if (this->scrollPosition_)
@@ -222,5 +220,5 @@
     }
 
-    std::list<std::string>::const_iterator Shell::getEndIterator() const
+    Shell::LineList::const_iterator Shell::getEndIterator() const
     {
         return this->outputLines_.end();
@@ -264,13 +262,5 @@
             if (this->bFinishedLastLine_)
             {
-                if (this->bPrependOutputLevel_)
-                {
-                    if (level == 0)
-                        output.insert(0, 1, static_cast<char>(-1));
-                    else
-                        output.insert(0, 1, static_cast<char>(level));
-                }
-
-                this->outputLines_.push_front(output);
+                this->outputLines_.push_front(std::make_pair(output, static_cast<LineType>(level)));
 
                 if (this->scrollPosition_)
@@ -288,5 +278,5 @@
             else
             {
-                (*this->outputLines_.begin()) += output;
+                this->outputLines_.front().first += output;
                 this->bFinishedLastLine_ = newline;
                 this->updateListeners<&ShellListener::onlyLastLineChanged>();
@@ -325,5 +315,5 @@
 
         if (!CommandExecutor::execute(this->inputBuffer_->get()))
-            this->addOutputLine("Error: Can't execute \"" + this->inputBuffer_->get() + "\".", 1);
+            this->addOutputLine("Error: Can't execute \"" + this->inputBuffer_->get() + "\".", Error);
 
         this->clearInput();
@@ -333,5 +323,5 @@
     {
         this->inputBuffer_->set(CommandExecutor::complete(this->inputBuffer_->get()));
-        this->addOutputLine(CommandExecutor::hint(this->inputBuffer_->get()), -1);
+        this->addOutputLine(CommandExecutor::hint(this->inputBuffer_->get()), Hint);
 
         this->inputChanged();
Index: /code/branches/presentation2/src/libraries/core/Shell.h
===================================================================
--- /code/branches/presentation2/src/libraries/core/Shell.h	(revision 6179)
+++ /code/branches/presentation2/src/libraries/core/Shell.h	(revision 6180)
@@ -65,5 +65,19 @@
     {
         public:
-            Shell(const std::string& consoleName, bool bScrollable, bool bPrependOutputLevel = false);
+            enum LineType
+            {
+                None    = OutputLevel::None,
+                Warning = OutputLevel::Warning,
+                Error   = OutputLevel::Error,
+                Info    = OutputLevel::Info,
+                Debug   = OutputLevel::Debug,
+                Verbose = OutputLevel::Verbose,
+                Ultra   = OutputLevel::Ultra,
+                Input,
+                Command,
+                Hint
+            };
+
+            Shell(const std::string& consoleName, bool bScrollable);
             ~Shell();
 
@@ -85,8 +99,9 @@
                 { return this->inputBuffer_->get(); }
 
-            std::list<std::string>::const_iterator getNewestLineIterator() const;
-            std::list<std::string>::const_iterator getEndIterator() const;
+            typedef std::list<std::pair<std::string, LineType> > LineList;
+            LineList::const_iterator getNewestLineIterator() const;
+            LineList::const_iterator getEndIterator() const;
 
-            void addOutputLine(const std::string& line, int level = 0);
+            void addOutputLine(const std::string& line, LineType type = None);
             void clearOutput();
 
@@ -139,6 +154,6 @@
             std::stringstream         outputBuffer_;
             bool                      bFinishedLastLine_;
-            std::list<std::string>    outputLines_;
-            std::list<std::string>::const_iterator scrollIterator_;
+            LineList                  outputLines_;
+            LineList::const_iterator  scrollIterator_;
             unsigned int              scrollPosition_;
             unsigned int              historyPosition_;
@@ -147,5 +162,4 @@
             std::string               promptPrefix_;
             const std::string         consoleName_;
-            const bool                bPrependOutputLevel_;
             const bool                bScrollable_;
 
Index: /code/branches/presentation2/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- /code/branches/presentation2/src/orxonox/overlays/InGameConsole.cc	(revision 6179)
+++ /code/branches/presentation2/src/orxonox/overlays/InGameConsole.cc	(revision 6180)
@@ -68,5 +68,5 @@
     */
     InGameConsole::InGameConsole()
-        : shell_(new Shell("InGameConsole", true, true))
+        : shell_(new Shell("InGameConsole", true))
         , consoleOverlay_(0)
         , consoleOverlayContainer_(0)
@@ -268,5 +268,5 @@
     void InGameConsole::linesChanged()
     {
-        std::list<std::string>::const_iterator it = this->shell_->getNewestLineIterator();
+        Shell::LineList::const_iterator it = this->shell_->getNewestLineIterator();
         int max = 0;
         for (int i = 1; i < LINES; ++i)
@@ -282,10 +282,10 @@
 
         for (int i = LINES - 1; i > max; --i)
-            this->print("", i, true);
+            this->print("", Shell::None, i, true);
 
         for (int i = max; i >= 1; --i)
         {
             --it;
-            this->print(*it, i, true);
+            this->print(it->first, it->second, i, true);
         }
     }
@@ -297,5 +297,5 @@
     {
         if (LINES > 1)
-            this->print(*this->shell_->getNewestLineIterator(), 1);
+            this->print(this->shell_->getNewestLineIterator()->first, this->shell_->getNewestLineIterator()->second, 1);
     }
 
@@ -316,5 +316,5 @@
     {
         if (LINES > 0)
-            this->print(this->shell_->getInput(), 0);
+            this->print(this->shell_->getInput(), Shell::Input, 0);
 
         if (this->shell_->getInput() == "" || this->shell_->getInput().size() == 0)
@@ -340,5 +340,5 @@
     void InGameConsole::executed()
     {
-        this->shell_->addOutputLine(this->shell_->getInput());
+        this->shell_->addOutputLine(this->shell_->getInput(), Shell::Command);
     }
 
@@ -456,18 +456,10 @@
         @param s String to be printed
     */
-    void InGameConsole::print(const std::string& text, int index, bool alwaysShift)
-    {
-        char level = 0;
-        if (text.size() > 0)
-            level = text[0];
-
+    void InGameConsole::print(const std::string& text, Shell::LineType type, int index, bool alwaysShift)
+    {
         std::string output = text;
-
-        if (level >= -1 && level <= 5)
-            output.erase(0, 1);
-
         if (LINES > index)
         {
-            this->colourLine(level, index);
+            this->colourLine(type, index);
 
             if (index > 0)
@@ -482,5 +474,5 @@
                     if (linesUsed > numLinesShifted_ || alwaysShift)
                         this->shiftLines();
-                    this->colourLine(level, index);
+                    this->colourLine(type, index);
                 }
                 this->consoleOverlayTextAreas_[index]->setCaption(multi_cast<Ogre::DisplayString>(output));
@@ -559,41 +551,39 @@
     }
 
-    void InGameConsole::colourLine(int colourcode, int index)
-    {
-        if (colourcode == -1)
-        {
-            this->consoleOverlayTextAreas_[index]->setColourTop   (ColourValue(0.90, 0.90, 0.90, 1.00));
-            this->consoleOverlayTextAreas_[index]->setColourBottom(ColourValue(1.00, 1.00, 1.00, 1.00));
-        }
-        else if (colourcode == 1)
-        {
-            this->consoleOverlayTextAreas_[index]->setColourTop   (ColourValue(0.95, 0.25, 0.25, 1.00));
-            this->consoleOverlayTextAreas_[index]->setColourBottom(ColourValue(1.00, 0.50, 0.50, 1.00));
-        }
-        else if (colourcode == 2)
-        {
-            this->consoleOverlayTextAreas_[index]->setColourTop   (ColourValue(0.95, 0.50, 0.20, 1.00));
-            this->consoleOverlayTextAreas_[index]->setColourBottom(ColourValue(1.00, 0.70, 0.50, 1.00));
-        }
-        else if (colourcode == 3)
-        {
-            this->consoleOverlayTextAreas_[index]->setColourTop   (ColourValue(0.50, 0.50, 0.95, 1.00));
-            this->consoleOverlayTextAreas_[index]->setColourBottom(ColourValue(0.80, 0.80, 1.00, 1.00));
-        }
-        else if (colourcode == 4)
-        {
-            this->consoleOverlayTextAreas_[index]->setColourTop   (ColourValue(0.65, 0.48, 0.44, 1.00));
-            this->consoleOverlayTextAreas_[index]->setColourBottom(ColourValue(1.00, 0.90, 0.90, 1.00));
-        }
-        else if (colourcode == 5)
-        {
-            this->consoleOverlayTextAreas_[index]->setColourTop   (ColourValue(0.40, 0.20, 0.40, 1.00));
-            this->consoleOverlayTextAreas_[index]->setColourBottom(ColourValue(0.80, 0.60, 0.80, 1.00));
-        }
-        else
-        {
-            this->consoleOverlayTextAreas_[index]->setColourTop   (ColourValue(0.21, 0.69, 0.21, 1.00));
-            this->consoleOverlayTextAreas_[index]->setColourBottom(ColourValue(0.80, 1.00, 0.80, 1.00));
-        }
+    void InGameConsole::colourLine(Shell::LineType type, int index)
+    {
+        ColourValue colourTop, colourBottom;
+        switch (type)
+        {
+        case Shell::Error:   colourTop = ColourValue(0.95, 0.25, 0.25, 1.00);
+                          colourBottom = ColourValue(1.00, 0.50, 0.50, 1.00); break;
+
+        case Shell::Warning: colourTop = ColourValue(0.95, 0.50, 0.20, 1.00);
+                          colourBottom = ColourValue(1.00, 0.70, 0.50, 1.00); break;
+
+        case Shell::Info:    colourTop = ColourValue(0.50, 0.50, 0.95, 1.00);
+                          colourBottom = ColourValue(0.80, 0.80, 1.00, 1.00); break;
+
+        case Shell::Debug:   colourTop = ColourValue(0.65, 0.48, 0.44, 1.00);
+                          colourBottom = ColourValue(1.00, 0.90, 0.90, 1.00); break;
+
+        case Shell::Verbose: colourTop = ColourValue(0.40, 0.20, 0.40, 1.00);
+                          colourBottom = ColourValue(0.80, 0.60, 0.80, 1.00); break;
+
+        case Shell::Ultra:   colourTop = ColourValue(0.21, 0.69, 0.21, 1.00);
+                          colourBottom = ColourValue(0.80, 1.00, 0.80, 1.00); break;
+
+        case Shell::Command: colourTop = ColourValue(0.80, 0.80, 0.80, 1.00);
+                          colourBottom = ColourValue(0.90, 0.90, 0.90, 0.90); break;
+
+        case Shell::Hint:    colourTop = ColourValue(0.80, 0.80, 0.80, 1.00);
+                          colourBottom = ColourValue(0.90, 0.90, 0.90, 1.00); break;
+
+        default:             colourTop = ColourValue(0.90, 0.90, 0.90, 1.00);
+                          colourBottom = ColourValue(1.00, 1.00, 1.00, 1.00); break;
+        }
+
+        this->consoleOverlayTextAreas_[index]->setColourTop   (colourTop);
+        this->consoleOverlayTextAreas_[index]->setColourBottom(colourBottom);
     }
 
Index: /code/branches/presentation2/src/orxonox/overlays/InGameConsole.h
===================================================================
--- /code/branches/presentation2/src/orxonox/overlays/InGameConsole.h	(revision 6179)
+++ /code/branches/presentation2/src/orxonox/overlays/InGameConsole.h	(revision 6180)
@@ -72,7 +72,7 @@
 
         void shiftLines();
-        void colourLine(int colourcode, int index);
+        void colourLine(Shell::LineType type, int index);
         void setCursorPosition(unsigned int pos);
-        void print(const std::string& text, int index, bool alwaysShift = false);
+        void print(const std::string& text, Shell::LineType type, int index, bool alwaysShift = false);
 
         void windowResized(unsigned int newWidth, unsigned int newHeight);