Index: /branches/christmas_branche/src/lib/graphics/importer/md2Model.cc
===================================================================
--- /branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6180)
+++ /branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6181)
@@ -177,5 +177,6 @@
 {
   glPushMatrix();
-  this->renderFrame();
+//   this->renderFrame();
+  renderFrameTriangles();
   glPopMatrix();
 }
@@ -223,4 +224,60 @@
   glPopAttrib();
 }
+
+
+
+
+
+void MD2Model::renderFrameTriangles() const
+{
+  static sVec3D verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
+  int* pCommands = this->data->pGLCommands;
+  /* some face culling stuff */
+//   glPushAttrib(GL_POLYGON_BIT);
+//   glFrontFace(GL_CW);
+//   glEnable(GL_CULL_FACE);
+//   glCullFace(GL_BACK);
+
+//   this->processLighting();
+//   this->interpolate(/*verticesList*/);
+  this->data->material->select();
+
+  /* draw the triangles */
+  glBegin(GL_TRIANGLES);
+
+  for( int i = 0, k = 0; i < this->data->numTriangles; ++i, k += 3)
+  {
+    //printf("%i: (%f, %f)\n", i, (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[2]].s, (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[2]].t);
+
+    glTexCoord2f((float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[0]].s,
+                  (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[0]].t);
+ //glNormal3f(Md2Model.normal[i].x, Md2Model.normal[i].y, Md2Model.normal[i].z);
+    glVertex3fv(this->data->pVertices[this->data->pTriangles[i].indexToVertices[0]]);
+
+    glTexCoord2f((float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[1]].s,
+                  (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[1]].t);
+
+ //    glNormal3f(Md2Model.normal[i].x, Md2Model.normal[i].y, Md2Model.normal[i].z);
+    glVertex3fv(this->data->pVertices[this->data->pTriangles[i].indexToVertices[1]]);
+
+    glTexCoord2f((float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[2]].s,
+                  (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[2]].t);
+ //    glNormal3f(Md2Model.normal[i].x, Md2Model.normal[i].y, Md2Model.normal[i].z);
+    glVertex3fv(this->data->pVertices[this->data->pTriangles[i].indexToVertices[2]]);
+  }
+
+  glEnd();
+}
+
+
+
+
+
+
+
+
+
+
+
 
 
Index: /branches/christmas_branche/src/lib/graphics/importer/md2Model.h
===================================================================
--- /branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6180)
+++ /branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6181)
@@ -214,4 +214,6 @@
 
   virtual void draw() const;
+  void renderFrameTriangles() const;
+
 
   void setAnim(int type);
Index: /branches/christmas_branche/src/world_entities/creatures/md2_creature.cc
===================================================================
--- /branches/christmas_branche/src/world_entities/creatures/md2_creature.cc	(revision 6180)
+++ /branches/christmas_branche/src/world_entities/creatures/md2_creature.cc	(revision 6181)
@@ -93,7 +93,7 @@
   cannon->setName("BFG");
 
-  //this->getWeaponManager()->addWeapon(wpLeft, 1, 0);
-  //this->getWeaponManager()->addWeapon(wpRight,1 ,1);
-  //this->getWeaponManager()->addWeapon(cannon, 0, 6);
+//   this->getWeaponManager()->addWeapon(wpLeft, 1, 0);
+//   this->getWeaponManager()->addWeapon(wpRight,1 ,1);
+//   this->getWeaponManager()->addWeapon(cannon, 0, 6);
 
   //this->getWeaponManager()->addWeapon(turret, 3, 0);
@@ -111,5 +111,5 @@
   this->setClassID(CL_MD2_CREATURE, "MD2Creature");
 
-  PRINTF(4)("SPACESHIP INIT\n");
+  PRINTF(4)("MD2CREATURE INIT\n");
 
   EventHandler::getInstance()->grabEvents(true);
@@ -247,5 +247,4 @@
 void MD2Creature::tick (float time)
 {
-
   if( likely(this->getModel(0) != NULL))
     ((MD2Model*)this->getModel(0))->tick(time);
@@ -289,4 +288,5 @@
   this->weaponAction();
 }
+
 
 /**