Index: branches/christmas_branche/src/lib/graphics/importer/md2Model.cc
===================================================================
--- branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6183)
+++ branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6184)
@@ -92,4 +92,6 @@
   this->scaleFactor = this->data->scaleFactor;
   this->setAnim(STAND);
+
+  this->debug();
 }
 
@@ -119,4 +121,6 @@
   currVec = &this->data->pVertices[this->data->numVertices * this->animationState.currentFrame];
   nextVec = &this->data->pVertices[this->data->numVertices * this->animationState.nextFrame];
+  PRINTF(0)("current frame nr %i, next frame nr %i\n", this->animationState.currentFrame, this->animationState.nextFrame);
+
 
   for( int i = 0; i < this->data->numVertices; ++i)
@@ -177,5 +181,5 @@
 {
   glPushMatrix();
-//   this->renderFrame();
+  //this->renderFrame();
   renderFrameTriangles();
   glPopMatrix();
@@ -231,5 +235,5 @@
 void MD2Model::renderFrameTriangles() const
 {
-  static sVec3D verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
+  //static sVec3D verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
   int* pCommands = this->data->pGLCommands;
   /* some face culling stuff */
@@ -248,20 +252,21 @@
   for( int i = 0, k = 0; i < this->data->numTriangles; ++i, k += 3)
   {
-    //printf("%i: (%f, %f)\n", i, (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[2]].s, (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[2]].t);
-
-    glTexCoord2f((float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[0]].s,
-                  (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[0]].t);
- //glNormal3f(Md2Model.normal[i].x, Md2Model.normal[i].y, Md2Model.normal[i].z);
+    float* v = this->data->pVertices[this->data->pTriangles[i].indexToVertices[0]];
+
+    printf("triangle: %i\n", i);
+    printf("     v0: (%f, %f, %f)\n", v[0], v[1], v[2]);
+    v = this->data->pVertices[this->data->pTriangles[i].indexToVertices[1]];
+    printf("     v1: (%f, %f, %f)\n", v[0], v[1], v[2]);
+    v = this->data->pVertices[this->data->pTriangles[i].indexToVertices[2]];
+    printf("     v2: (%f, %f, %f)\n", v[0], v[1], v[2]);
+
+
+    glNormal3f(anorms[i][0], anorms[i][1], anorms[i][2]);
     glVertex3fv(this->data->pVertices[this->data->pTriangles[i].indexToVertices[0]]);
 
-    glTexCoord2f((float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[1]].s,
-                  (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[1]].t);
-
- //    glNormal3f(Md2Model.normal[i].x, Md2Model.normal[i].y, Md2Model.normal[i].z);
+    glNormal3f(anorms[i][0], anorms[i][1], anorms[i][2]);
     glVertex3fv(this->data->pVertices[this->data->pTriangles[i].indexToVertices[1]]);
 
-    glTexCoord2f((float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[2]].s,
-                  (float)this->data->pTexCoor[this->data->pTriangles[i].indexToTexCoor[2]].t);
- //    glNormal3f(Md2Model.normal[i].x, Md2Model.normal[i].y, Md2Model.normal[i].z);
+    glNormal3f(anorms[i][0], anorms[i][1], anorms[i][2]);
     glVertex3fv(this->data->pVertices[this->data->pTriangles[i].indexToVertices[2]]);
   }
@@ -269,13 +274,4 @@
   glEnd();
 }
-
-
-
-
-
-
-
-
-
 
 
@@ -451,4 +447,5 @@
   for(int i = 0; i < this->numFrames; ++i)
     {
+      printf("==============vertex loading for frame %i/%i========\n", i, this->numFrames);
       frame = (sFrame*)(buffer + this->header->frameSize * i);
       pVertex = this->pVertices + this->numVertices  * i;
@@ -462,4 +459,6 @@
           pVertex[j][2] = (-1.0 * (frame->pVertices[j].v[1] * frame->scale[1] + frame->translate[1])) * this->scaleFactor;
 
+          printf("vertex %i/%i: (%f, %f, %f)\n", j, this->numVertices, pVertex[j][0], pVertex[j][1], pVertex[j][2]);
+
           pNormals[j] = frame->pVertices[j].lightNormalIndex;
         }
Index: branches/christmas_branche/src/subprojects/importer/Makefile.am
===================================================================
--- branches/christmas_branche/src/subprojects/importer/Makefile.am	(revision 6183)
+++ branches/christmas_branche/src/subprojects/importer/Makefile.am	(revision 6184)
@@ -24,7 +24,6 @@
                   $(MAINSRCDIR)/lib/math/vector.cc \
                   $(MAINSRCDIR)/util/loading/resource_manager.cc \
-                  $(MAINSRCDIR)/lib/util/ini_parser.cc \
+                  $(MAINSRCDIR)/lib/parser/ini_parser/ini_parser.cc \
                   $(MAINSRCDIR)/lib/coord/p_node.cc \
-                  $(MAINSRCDIR)/lib/coord/null_parent.cc \
                   $(MAINSRCDIR)/util/loading/load_param.cc \
                   $(MAINSRCDIR)/util/loading/load_param_description.cc \
@@ -52,7 +51,6 @@
                   $(MAINSRCDIR)/lib/math/vector.cc \
                   $(MAINSRCDIR)/util/loading/resource_manager.cc \
-                  $(MAINSRCDIR)/lib/util/ini_parser.cc \
+                  $(MAINSRCDIR)/lib/parser/ini_parser/ini_parser.cc \
                   $(MAINSRCDIR)/lib/coord/p_node.cc \
-                  $(MAINSRCDIR)/lib/coord/null_parent.cc \
                   $(MAINSRCDIR)/util/loading/load_param.cc \
                   $(MAINSRCDIR)/util/loading/load_param_description.cc \
Index: branches/christmas_branche/src/subprojects/importer/importer.cc
===================================================================
--- branches/christmas_branche/src/subprojects/importer/importer.cc	(revision 6183)
+++ branches/christmas_branche/src/subprojects/importer/importer.cc	(revision 6184)
@@ -21,4 +21,5 @@
 
 #include "objModel.h"
+#include "md2Model.h"
 #include "primitive_model.h"
 #include <stdlib.h>
@@ -40,7 +41,17 @@
 
   if (argc>=3)
-    obj = new OBJModel (argv[1], atof(argv[2]));
+  {
+    if( strstr(argv[1], ".obj") != NULL)
+      obj = new OBJModel (argv[1], atof(argv[2]));
+    else if( strstr(argv[1], ".md2") != NULL)
+      obj = new MD2Model(argv[1], argv[2]);
+  }
   else if (argc>=2)
-    obj = new OBJModel(argv[1]);
+  {
+    if( strstr(argv[1], ".obj") != NULL)
+      obj = new OBJModel(argv[1]);
+    else if( strstr(argv[1], ".md2") != NULL)
+      obj = new MD2Model(argv[1], "fake_texture.bad");
+  }
   else
     obj = new PrimitiveModel(PRIM_CYLINDER);