Index: branches/christmas_branche/src/lib/graphics/importer/md2Model.cc
===================================================================
--- branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6189)
+++ branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6191)
@@ -121,6 +121,4 @@
   currVec = &this->data->pVertices[this->data->numVertices * this->animationState.currentFrame];
   nextVec = &this->data->pVertices[this->data->numVertices * this->animationState.nextFrame];
-  PRINTF(0)("current frame nr %i, next frame nr %i\n", this->animationState.currentFrame, this->animationState.nextFrame);
-
 
   for( int i = 0; i < this->data->numVertices; ++i)
@@ -215,5 +213,4 @@
         }
 
-
       for(; i > 0; i--, pCommands += 3) /* down counting for loop, next 3 gl commands */
         {
@@ -242,5 +239,5 @@
 //   glEnable(GL_CULL_FACE);
 //   glCullFace(GL_BACK);
-
+//
 //   this->processLighting();
 //   this->interpolate(/*verticesList*/);
@@ -352,6 +349,6 @@
   this->numTexCoor = 0;
 
-  this->scaleFactor = 1.0f;
-//   this->scaleFactor = 0.2f;
+//   this->scaleFactor = 1.0f;
+  this->scaleFactor = 0.2f;
 
   this->fileName = NULL;
@@ -448,5 +445,4 @@
   for(int i = 0; i < this->numFrames; ++i)
     {
-      printf("==============vertex loading for frame %i/%i========\n", i, this->numFrames);
       frame = (sFrame*)(buffer + this->header->frameSize * i);
       pVertex = this->pVertices + this->numVertices  * i;
@@ -460,10 +456,5 @@
            pVertex[j][2] = (-1.0 * (frame->pVertices[j].v[1] * frame->scale[1] + frame->translate[1])) * this->scaleFactor;
 
-//            pVertex[j][0] = ((frame->pVertices[j].v[0] /** frame->scale[0]*/ )/* + frame->translate[0]*/ );
-//            pVertex[j][2] = (-1.0f * (frame->pVertices[j].v[2] /** frame->scale[2]*/) /*+ frame->translate[2]*/);
-//            pVertex[j][1] = ((frame->pVertices[j].v[1] /** frame->scale[1]*/ /*+ frame->translate[1]*/));
-
-
-          printf("vertex %i/%i: (%f, %f, %f)\n", j, this->numVertices, pVertex[j][0], pVertex[j][1], pVertex[j][2]);
+          //printf("vertex %i/%i: (%f, %f, %f)\n", j, this->numVertices, pVertex[j][0], pVertex[j][1], pVertex[j][2]);
 
           pNormals[j] = frame->pVertices[j].lightNormalIndex;
Index: branches/christmas_branche/src/lib/graphics/importer/md2Model.h
===================================================================
--- branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6189)
+++ branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6191)
@@ -69,5 +69,5 @@
 typedef struct
 {
-  unsigned char             v[3];                 //!< the vector of the vertex
+  unsigned char    v[3];                 //!< the vector of the vertex
   unsigned char    lightNormalIndex;     //!< the index of the light normal
 } sVertex;
Index: branches/christmas_branche/src/subprojects/importer/importer.cc
===================================================================
--- branches/christmas_branche/src/subprojects/importer/importer.cc	(revision 6189)
+++ branches/christmas_branche/src/subprojects/importer/importer.cc	(revision 6191)
@@ -45,5 +45,8 @@
       obj = new OBJModel (argv[1], atof(argv[2]));
     else if( strstr(argv[1], ".md2") != NULL)
+    {
       obj = new MD2Model(argv[1], argv[2]);
+      ((MD2Model*)obj)->tick(0.1f);
+    }
   }
   else if (argc>=2)
@@ -51,6 +54,9 @@
     if( strstr(argv[1], ".obj") != NULL)
       obj = new OBJModel(argv[1]);
-    else if( strstr(argv[1], ".md2") != NULL)
+    else if( strstr(argv[1], ".md2") != NULL) {
       obj = new MD2Model(argv[1], "fake_texture.bad");
+      obj = new MD2Model(argv[1], argv[2]);
+      ((MD2Model*)obj)->tick(0.1f);
+    }
   }
   else
Index: branches/christmas_branche/src/world_entities/world_entity.cc
===================================================================
--- branches/christmas_branche/src/world_entities/world_entity.cc	(revision 6189)
+++ branches/christmas_branche/src/world_entities/world_entity.cc	(revision 6191)
@@ -85,10 +85,14 @@
   static_cast<PNode*>(this)->loadParams(root);
 
+  LoadParam(root, "md2texture", this, WorldEntity, loadMD2Texture)
+      .describe("the fileName of the texture, that should be loaded onto this world-entity. (must be relative to the data-dir)")
+      .defaultValues(1, NULL);
+
   // Model Loading
   LoadParam(root, "model", this, WorldEntity, loadModel)
       .describe("the fileName of the model, that should be loaded onto this world-entity. (must be relative to the data-dir)")
       .defaultValues(3, NULL, 1.0f, 0);
-
-}
+}
+
 
 /**
@@ -135,5 +139,5 @@
       PRINTF(4)("fetching MD2 file: %s\n", fileName);
 //         MD2Model* m = (MD2Model*)ResourceManager::getInstance()->load(fileName, MD2, RP_CAMPAIGN);
-      Model* m = new MD2Model(fileName, "md2_fake_texture.bad");
+      Model* m = new MD2Model(fileName, this->md2TextureFileName);
         //this->setModel((Model*)ResourceManager::getInstance()->load(fileName, MD2, RP_CAMPAIGN), 0);
       this->setModel(m, 0);
Index: branches/christmas_branche/src/world_entities/world_entity.h
===================================================================
--- branches/christmas_branche/src/world_entities/world_entity.h	(revision 6189)
+++ branches/christmas_branche/src/world_entities/world_entity.h	(revision 6191)
@@ -36,4 +36,6 @@
   void setModel(Model* model, unsigned int modelNumber = 0);
   Model* getModel(unsigned int modelNumber = 0) const { return (this->models.size() > modelNumber)? this->models[modelNumber] : NULL; };
+
+  inline void loadMD2Texture(const char* fileName) { this->md2TextureFileName = fileName; }
 
   bool buildObbTree(unsigned int depth);
@@ -79,4 +81,5 @@
  private:
   std::vector<Model*>     models;             //!< The model that should be loaded for this entity.
+  const char*             md2TextureFileName; //!< the file name of the md2 model texture, only if this
   BVTree*                 obbTree;            //!< this is the obb tree reference needed for collision detection
 